Index: trunk/kernel/mm/vseg.c
===================================================================
--- trunk/kernel/mm/vseg.c	(revision 690)
+++ trunk/kernel/mm/vseg.c	(revision 1)
@@ -2,5 +2,7 @@
  * vseg.c - virtual segment (vseg) related operations
  *
- * Authors   Alain Greiner (2016,2017,2018,2019,2020)
+ * Authors   Ghassan Almaless (2008,2009,2010,2011, 2012)
+ *           Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -8,9 +10,9 @@
  * This file is part of ALMOS-MKH.
  *
- * ALMOS-MKH is free software; you can redistribute it and/or modify it
+ * ALMOS-MKH.is free software; you can redistribute it and/or modify it
  * under the terms of the GNU General Public License as published by
  * the Free Software Foundation; version 2.0 of the License.
  *
- * ALMOS-MKH is distributed in the hope that it will be useful, but
+ * ALMOS-MKH.is distributed in the hope that it will be useful, but
  * WITHOUT ANY WARRANTY; without even the implied warranty of
  * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
@@ -18,9 +20,9 @@
  *
  * You should have received a copy of the GNU General Public License
- * along with ALMOS-MKH; if not, write to the Free Software Foundation,
+ * along with ALMOS-MKH.; if not, write to the Free Software Foundation,
  * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
  */
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
 #include <hal_special.h>
 #include <hal_remote.h>
@@ -33,4 +35,5 @@
 #include <ppm.h>
 #include <mapper.h>
+#include <spinlock.h>
 #include <vfs.h>
 #include <page.h>
@@ -40,27 +43,32 @@
 
 ////////////////////////////////////////////////////////////////////////////////////////
-//   global variables for display / must be consistent with enum in "vseg.h"
+//   global variables for display / must be consistant with enum in "vseg.h"
 ////////////////////////////////////////////////////////////////////////////////////////
 
-
-//////////////////////////////////////////
-char * vseg_type_str( uint32_t vseg_type )
-{
-  	if     ( vseg_type == VSEG_TYPE_CODE   ) return "CODE";
-  	else if( vseg_type == VSEG_TYPE_DATA   ) return "DATA";
-  	else if( vseg_type == VSEG_TYPE_STACK  ) return "STAK";
-  	else if( vseg_type == VSEG_TYPE_ANON   ) return "ANON";
-  	else if( vseg_type == VSEG_TYPE_FILE   ) return "FILE";
-  	else if( vseg_type == VSEG_TYPE_REMOTE ) return "REMO";
-  	else if( vseg_type == VSEG_TYPE_KCODE  ) return "KCOD";
-  	else if( vseg_type == VSEG_TYPE_KDATA  ) return "KDAT";
-  	else if( vseg_type == VSEG_TYPE_KDEV   ) return "KDEV";
-    else                                     return "undefined";
-}
-
-///////////////////////////
-vseg_t * vseg_alloc( void )
-{
-    return (vseg_t*)kmem_alloc( bits_log2( sizeof(vseg_t)) , AF_ZERO );
+const char* vseg_type_name[VSEG_TYPES_NR] =
+{
+	"CODE",
+	"DATA",
+    "HEAP",
+    "STACK",
+    "ANON",
+    "FILE",
+    "REMOTE",
+    "KCODE",
+    "KDATA",
+    "KDEV",
+};
+
+
+/////////////////////
+vseg_t * vseg_alloc()
+{
+    kmem_req_t   req;
+
+    req.type  = KMEM_VSEG;
+	req.size  = sizeof(vseg_t);
+	req.flags = AF_KERNEL;
+
+    return (vseg_t *)kmem_alloc( &req );
 }
 
@@ -68,16 +76,37 @@
 void vseg_free( vseg_t * vseg )
 {
-	kmem_free( vseg , bits_log2( sizeof(vseg_t)) );
-}
-
-/////////////////////////////////////////
-void vseg_init_flags( vseg_t      * vseg,
-                      vseg_type_t   type )
-{
+    kmem_req_t  req;
+
+	req.type = KMEM_VSEG;
+	req.ptr  = vseg;
+	kmem_free( &req );
+}
+
+///////////////////////////////////
+void vseg_init( vseg_t      * vseg,
+	            intptr_t      base, 
+                intptr_t      size,
+                vpn_t         vpn_base,
+                vpn_t         vpn_size,
+		        uint32_t      type,
+                cxy_t         cxy,
+                fdid_t        fdid,
+		        uint32_t      offset )
+{
+    vseg->type      = type;
+	vseg->min       = base;
+	vseg->max       = base + size;
+    vseg->vpn_base  = vpn_base;
+	vseg->vpn_size  = vpn_size;
+	vseg->mapper    = XPTR_NULL;
+	vseg->fdid      = fdid;
+	vseg->offset    = offset;
+    vseg->cxy       = cxy;
+
     // set vseg flags depending on type
-	if( type == VSEG_TYPE_CODE )
-    {
-        vseg->flags = VSEG_USER    |
-                      VSEG_EXEC    |
+	if     ( type == VSEG_TYPE_CODE ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_EXEC    | 
                       VSEG_CACHE   |
                       VSEG_PRIVATE ;
@@ -88,102 +117,118 @@
                       VSEG_WRITE   |
                       VSEG_CACHE   |
+                      VSEG_PRIVATE ; 
+    }
+    else if( type == VSEG_TYPE_DATA ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_WRITE   |
+                      VSEG_CACHE   | 
+                      VSEG_DISTRIB ;
+    }
+    else if( type == VSEG_TYPE_HEAP ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_WRITE   |
+                      VSEG_CACHE   |
+                      VSEG_DISTRIB ;
+    }
+    else if( type == VSEG_TYPE_REMOTE ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_WRITE   | 
+                      VSEG_CACHE   ; 
+    }
+    else if( type == VSEG_TYPE_ANON ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_WRITE   |
+                      VSEG_CACHE   |
+                      VSEG_DISTRIB ;
+    }
+    else if( type == VSEG_TYPE_FILE ) 
+    {
+        vseg->flags = VSEG_USER    |
+                      VSEG_WRITE   |
+                      VSEG_CACHE   ;
+    }
+    else if( type == VSEG_TYPE_KCODE ) 
+    {
+        vseg->flags = VSEG_EXEC    |
+                      VSEG_CACHE   |
                       VSEG_PRIVATE ;
     }
-    else if( type == VSEG_TYPE_DATA )
-    {
-        vseg->flags = VSEG_USER    |
-                      VSEG_WRITE   |
-                      VSEG_CACHE   |
-                      VSEG_DISTRIB ;
-    }
-    else if( type == VSEG_TYPE_REMOTE )
-    {
-        vseg->flags = VSEG_USER    |
-                      VSEG_WRITE   |
-                      VSEG_CACHE   ;
-    }
-    else if( type == VSEG_TYPE_ANON )
-    {
-        vseg->flags = VSEG_USER    |
-                      VSEG_WRITE   |
-                      VSEG_CACHE; 
-    }
-    else if( type == VSEG_TYPE_FILE )
-    {
-        vseg->flags = VSEG_USER    |
-                      VSEG_WRITE   |
-                      VSEG_CACHE   ;
-    }
-    else if( type == VSEG_TYPE_KCODE )
-    {
-        vseg->flags = VSEG_EXEC    |
+    else if( type == VSEG_TYPE_KDATA ) 
+    {
+        vseg->flags = VSEG_WRITE   |
                       VSEG_CACHE   |
                       VSEG_PRIVATE ;
     }
-    else if( type == VSEG_TYPE_KDATA )
-    {
-        vseg->flags = VSEG_CACHE   |
-                      VSEG_WRITE   ;
-    }
-    else if( type == VSEG_TYPE_KDEV )
-    {
-        vseg->flags = VSEG_WRITE   ;
-    }
-    else
-    {
-	    assert( __FUNCTION__, false , "illegal vseg type\n" );
-    }
-
+    else 
+    {
+	    printk("\n[PANIC] in %s : illegal vseg type\n", __FUNCTION__);
+        hal_core_sleep();
+    }  
 }  // end vseg_init()
 
 //////////////////////////////////////////
 void vseg_init_from_ref( vseg_t    * vseg,
-                         xptr_t      ref_xp )
+                         xptr_t      ref )
 {
     // get remote vseg cluster and pointer
-    cxy_t    cxy = (cxy_t   )GET_CXY( ref_xp );
-    vseg_t * ptr = (vseg_t *)GET_PTR( ref_xp );
+    cxy_t    cxy = (cxy_t   )GET_CXY( ref );
+    vseg_t * ptr = (vseg_t *)GET_PTR( ref );
 
     // initialize vseg with remote_read access
-    vseg->type        =           hal_remote_l32( XPTR( cxy , &ptr->type        ) );
-    vseg->min         = (intptr_t)hal_remote_lpt( XPTR( cxy , &ptr->min         ) );
-    vseg->max         = (intptr_t)hal_remote_lpt( XPTR( cxy , &ptr->max         ) );
-    vseg->vpn_base    =           hal_remote_l32( XPTR( cxy , &ptr->vpn_base    ) );
-    vseg->vpn_size    =           hal_remote_l32( XPTR( cxy , &ptr->vpn_size    ) );
-    vseg->flags       =           hal_remote_l32( XPTR( cxy , &ptr->flags       ) );
-    vseg->file_offset =           hal_remote_l32( XPTR( cxy , &ptr->file_offset ) );
-    vseg->file_size   =           hal_remote_l32( XPTR( cxy , &ptr->file_size   ) );
-	vseg->mapper_xp   = (xptr_t)  hal_remote_l64( XPTR( cxy , &ptr->mapper_xp   ) );
-
-    switch (vseg->type)
-    {
-        case VSEG_TYPE_DATA:      // unused 
-        {
-            vseg->cxy = 0xffff;
-            break;
-        }
-        case VSEG_TYPE_CODE:      // always local
-        case VSEG_TYPE_STACK: 
-        case VSEG_TYPE_KCODE:
-        {
-            vseg->cxy = local_cxy;
-            break;
-        }
-        case VSEG_TYPE_ANON:      // intrinsic
-        case VSEG_TYPE_FILE:
-        case VSEG_TYPE_REMOTE: 
-        case VSEG_TYPE_KDEV:
-        case VSEG_TYPE_KDATA:
-        {
-            vseg->cxy = (cxy_t) hal_remote_l32( XPTR(cxy, &ptr->cxy) );
-            break;
-        }
-        default: 
-        {
-            assert( __FUNCTION__, false, "Illegal vseg type" );
-            break;
-        }
-    }
-}
-
-
+    vseg->type     =           hal_remote_lw ( XPTR( cxy , &ptr->type     ) );
+    vseg->min      = (intptr_t)hal_remote_lpt( XPTR( cxy , &ptr->min      ) );
+    vseg->max      = (intptr_t)hal_remote_lpt( XPTR( cxy , &ptr->max      ) );
+    vseg->vpn_base =           hal_remote_lw ( XPTR( cxy , &ptr->vpn_base ) );
+    vseg->vpn_size =           hal_remote_lw ( XPTR( cxy , &ptr->vpn_size ) );
+    vseg->flags    =           hal_remote_lw ( XPTR( cxy , &ptr->flags    ) );
+	vseg->mapper   = (xptr_t)  hal_remote_lwd( XPTR( cxy , &ptr->mapper   ) );
+
+    if( vseg->type == VSEG_TYPE_FILE )
+    {
+        vseg->fdid   = hal_remote_lw( XPTR( cxy , &ptr->fdid   ) );
+        vseg->offset = hal_remote_lw( XPTR( cxy , &ptr->offset ) );
+    }
+    else
+    {
+        vseg->fdid   = 0;
+        vseg->offset = 0;
+    }
+} // end vseg_init_from_ref()
+
+
+///////////////////////////////
+error_t vseg_attach( vmm_t  * vmm,
+                     vseg_t * vseg )
+{
+    // add vseg in radix-tree
+    error_t error = grdxt_insert( &vmm->grdxt , vseg->vpn_base , vseg );
+    if ( error ) return ENOMEM;
+
+    // update vseg descriptor
+    vseg->vmm = vmm;
+
+    // add vseg in vmm list
+    list_add_last( &vmm->vsegs_root , &vseg->list );
+
+    return 0;
+}
+
+///////////////////////////////
+void vseg_detach( vmm_t  * vmm,
+                  vseg_t * vseg )
+{
+    // remove vseg from radix-tree
+    grdxt_remove( &vmm->grdxt , vseg->vpn_base );
+
+    // update vseg descriptor
+    vseg->vmm = NULL;
+
+    // remove vseg from vmm list
+    list_unlink( &vseg->list );
+}
+
+
Index: trunk/kernel/mm/vseg.h
===================================================================
--- trunk/kernel/mm/vseg.h	(revision 690)
+++ trunk/kernel/mm/vseg.h	(revision 1)
@@ -2,5 +2,7 @@
  * vseg.h - virtual segment (vseg) related operations
  *
- * Authors  Alain Greiner (2016,2017,2018,2019,2020)
+ * Authors   Ghassan Almaless (2008,2009,2010,2011, 2012)
+ *           Mohamed Lamine Karaoui (2015)
+ *           Alain Greiner (2016)
  *
  * Copyright (c) UPMC Sorbonne Universites
@@ -25,5 +27,6 @@
 #define _VSEG_H_
 
-#include <hal_kernel_types.h>
+#include <hal_types.h>
+#include <spinlock.h>
 #include <vfs.h>
 
@@ -32,105 +35,129 @@
 struct vmm_s;
 
-/*******************************************************************************************
- * This enum defines the vseg types.
- * Note : the KDATA and KDEV types are not used by the TSAR HAL, because the accesses
- *        to kernel data or kernel devices are done through the DATA extension address
- *        register, but these types are probably required by the I86 HAL [AG].
- ******************************************************************************************/
+/**********************************************************************************************
+ * This enum defines the vseg types
+ *********************************************************************************************/
 
-typedef enum
+enum
 {
-    VSEG_TYPE_CODE   = 1,          /*! executable user code     / private / localized     */
-    VSEG_TYPE_DATA   = 2,          /*! initialized user data    / public  / distributed   */
-    VSEG_TYPE_STACK  = 3,          /*! execution user stack     / private / localized     */
-    VSEG_TYPE_ANON   = 4,          /*! anonymous mmap           / public  / localized     */
-    VSEG_TYPE_FILE   = 5,          /*! file mmap                / public  / localized     */
-    VSEG_TYPE_REMOTE = 6,          /*! remote mmap              / public  / localized     */
+    VSEG_TYPE_CODE   = 0,          /*! executable code        / private / localized          */
+    VSEG_TYPE_DATA   = 1,          /*! initialized data       / public  / distributed        */
+    VSEG_TYPE_HEAP   = 2,          /*! standard malloc        / public  / distributed        */
+    VSEG_TYPE_STACK  = 3,          /*! execution stack        / private / localized          */
+    VSEG_TYPE_ANON   = 4,          /*! anonymous mmap         / public  / localized          */
+    VSEG_TYPE_FILE   = 5,          /*! file mmap              / public  / localized          */
+    VSEG_TYPE_REMOTE = 6,          /*! remote mmap            / public  / localized          */
+    VSEG_TYPE_KCODE  = 7,          /*! kernel code            / private / localized          */
+    VSEG_TYPE_KDATA  = 8,          /*! kernel data            / private / localized          */
+    VSEG_TYPE_KDEV   = 9,          /*! device segment         / public  / localized          */
 
-    VSEG_TYPE_KCODE  = 7,          /*! executable kernel code   / private / localized     */
-    VSEG_TYPE_KDATA  = 8,          /*! initialized kernel data  / private / localized     */
-    VSEG_TYPE_KDEV   = 9,          /*! kernel peripheral device / public  / localized     */
-}
-vseg_type_t;
+    VSEG_TYPES_NR    = 10,
+};
 
 
-/*******************************************************************************************
- * These masks define the vseg generic (hardware independent) flags.
- ******************************************************************************************/
+/**********************************************************************************************
+ * These masks define the vseg generic (hardware independant) flags.
+ *********************************************************************************************/
 
-#define VSEG_USER     0x0001       /*! user accessible                                    */
-#define VSEG_WRITE    0x0002       /*! writeable                                          */
-#define VSEG_EXEC     0x0004       /*! executable                                         */
-#define VSEG_CACHE    0x0008       /*! cachable                                           */
-#define VSEG_PRIVATE  0x0010       /*! should not be accessed from another cluster        */
-#define VSEG_DISTRIB  0x0020       /*! physically distributed on all clusters             */
+#define VSEG_USER     0x0001       /*! user accessible                                       */
+#define VSEG_WRITE    0x0002       /*! writeable                                             */
+#define VSEG_EXEC     0x0004       /*! executable                                            */
+#define VSEG_CACHE    0x0008       /*! cachable                                              */
+#define VSEG_PRIVATE  0x0010       /*! should not be accessed from another cluster           */
+#define VSEG_DISTRIB  0x0020       /*! physically distributed on all clusters                */
 
-/*******************************************************************************************
+/**********************************************************************************************
  * This structure defines a virtual segment descriptor.
- * The VSL contains only local vsegs, but is implemented as an xlist, because it can be
- * accessed by a thread running in a remote cluster.
- * The xlist field is also used to implement the zombi lists used by the MMAP allocator.
- ******************************************************************************************/
+ *********************************************************************************************/
 
 typedef struct vseg_s
 {
-    xlist_entry_t     xlist;        /*! all vsegs in same VSL                             */
-    struct vmm_s    * vmm;          /*! pointer on associated VM manager                  */
-    uint32_t          type;         /*! vseg type                                         */
-    intptr_t          min;          /*! segment min virtual address                       */
-    intptr_t          max;          /*! segment max virtual address (excluded)            */
-    vpn_t             vpn_base;     /*! first page of vseg                                */
-    vpn_t             vpn_size;     /*! number of pages occupied                          */
-    xptr_t            mapper_xp;    /*! xptr on remote mapper (for types CODE/DATA/FILE)  */
-    uint32_t          flags;        /*! vseg attributes                                   */
-    intptr_t          file_offset;  /*! vseg offset in file (for types CODE/DATA/FILE)    */
-    intptr_t          file_size;    /*! max segment size in mapper (for type CODE/DATA)   */
-    cxy_t             cxy;          /*! physical mapping (for non distributed vseg)       */ 
+	list_entry_t      list;         /*! all vsegs in same process / same free list if mmap   */
+	struct vmm_s    * vmm;          /*! pointer on associated VM manager                     */
+    uint32_t          type;         /*! vseg type                                            */
+	intptr_t          min;          /*! segment min virtual address                          */
+	intptr_t          max;          /*! segment max virtual address (excluded)               */
+	vpn_t             vpn_base;     /*! first page of vseg                                   */
+	vpn_t             vpn_size;     /*! numbre of pages occupied                             */
+	uint32_t          flags;        /*! vseg attributes                                      */
+	xptr_t            mapper;       /*! extended pointer on associated mapper                */
+	fdid_t            fdid;         /*! associated fdid for a VSEG_TYPE_FILE                 */
+	uint32_t          offset;       /*! offset in file for a VSEG_TYPE_FILE                  */
+    cxy_t             cxy;          /*! target cluster for physical mapping                  */
 }
 vseg_t;
 
-/*******************************************************************************************
- * This function returns a printable string for the vseg type. 
- *******************************************************************************************
- * @ vseg_type  : type of vseg
- * @ return pointer on string
- ******************************************************************************************/
-char * vseg_type_str( uint32_t vseg_type );
-
-/*******************************************************************************************
+/**********************************************************************************************
  * This function allocates physical memory for a new vseg descriptor from the local cluster
  * physical memory allocator.
- *******************************************************************************************
+ **********************************************************************************************
  * @ return pointer on allocated vseg descriptor if success / return NULL if failure.
- ******************************************************************************************/
-vseg_t * vseg_alloc( void );
+ *********************************************************************************************/
+vseg_t * vseg_alloc();
 
-/*******************************************************************************************
- * This function releases the physical memory allocated for a vseg descriptor 
- * to the local cluster physical memory allocator.
- *******************************************************************************************
+/**********************************************************************************************
+ * This function releases physical memory allocated for a vseg descriptor to the local cluster
+ * physical memory allocator.
+ **********************************************************************************************
  * @ vseg   : local pointer on released vseg descriptor.
- ******************************************************************************************/
+ *********************************************************************************************/
 void vseg_free( vseg_t * vseg );
 
-/*******************************************************************************************
- * This function initializes the "flags" field for a local <vseg> descriptor,
- * depending on the vseg <type>. 
- *******************************************************************************************
+/**********************************************************************************************
+ * This function initializes a local vseg descriptor, from the arguments values.
+ * It does NOT register the vseg in the local VMM.
+ **********************************************************************************************
  * @ vseg      : pointer on the vseg descriptor.
+ * @ base      : vseg base address.
+ * @ size      : vseg size (bytes).
+ * @ vpn_base  : first page index.
+ * @ vpn_size  : number of pages.
  * @ type      : vseg type.
- ******************************************************************************************/
-void vseg_init_flags( vseg_t      * vseg,
-	                  vseg_type_t   type );
+ * @ cxy       : target cluster for physical mapping.
+ * @ fdid      : file descriptor index if VSEG_TYPE_FILE.
+ * @ offset    : offset in file if VSEG_TYPE_FILE.
+ *********************************************************************************************/
+void vseg_init( vseg_t      * vseg,
+                intptr_t      base, 
+	            intptr_t      size, 
+                vpn_t         vpn_base,
+                vpn_t         vpn_size,
+	            uint32_t      type,
+                cxy_t         cxy,
+                fdid_t        fdid,
+	            uint32_t      offset );
 
-/*******************************************************************************************
+/**********************************************************************************************
  * This function initializes a local vseg descriptor from values contained in a reference
  * remote vseg descriptor. It does NOT register the vseg in the local VMM.
- *******************************************************************************************
+ **********************************************************************************************
  * @ vseg      : pointer on the vseg descriptor.
- * @ ref_xp    : extended pointer on the reference vseg descriptor.
- ******************************************************************************************/
+ * @ src       : extended pointer on the reference vseg descriptor.
+ *********************************************************************************************/
 void vseg_init_from_ref( vseg_t * vseg,
-                         xptr_t   ref_xp );
+                         xptr_t   ref );
+
+/**********************************************************************************************
+ * This function add a vseg descriptor in the set of vsegs controled by a given VMM,
+ * and update the vmm field in the vseg descriptor. 
+ * The lock protecting the vsegs list in VMM must be taken by the caller.
+ **********************************************************************************************
+ * @ vmm       : pointer on the VMM
+ * @ vseg      : pointer on the vseg descriptor
+ * @ returns 0 if success / returns ENOMEM if failure.
+ *********************************************************************************************/
+error_t vseg_attach( struct vmm_s  * vmm, 
+                     vseg_t        * vseg );
+
+/**********************************************************************************************
+ * This function removes a vseg descriptor from the set of vsegs controled by a given VMM,
+ * and update the vmm field in the vseg descriptor. No memory is released.
+ * The lock protecting the vsegs list in VMM must be taken by the caller.
+ **********************************************************************************************
+ * @ vmm       : pointer on the VMM
+ * @ vseg      : pointer on the vseg descriptor
+ *********************************************************************************************/
+void vseg_detach( struct vmm_s  * vmm, 
+                  vseg_t        * vseg );
 
 
